/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package sos.scheduler.editor.doc;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.util.HashMap;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;




import com.sos.JSHelper.Basics.JSToolBox;
import com.sos.JSHelper.DataElements.JSDataElementDate;
import com.sos.JSHelper.DataElements.JSDateFormat;
import com.sos.JSHelper.io.Files.JSXMLFile;
import com.sos.VirtualFileSystem.FTP.FTPIllegalReplyException;
 

/**
* \class SourceGenerator 
* 
* \brief SourceGenerator - 
* 
* \details
*
* \section SourceGenerator.java_intro_sec Introduction
*
* \section SourceGenerator.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 29.09.2011
* \see reference
*
* Created on 29.09.2011 15:38:57
 */

public class SourceGenerator {

 	private final String	conClassName	= "SourceGenerator";


 
	private final String								conXsltParmExtendsClassName		= "ExtendsClassName";
	private final String								conXsltParmClassNameExtension	= "ClassNameExtension";
	private final String								conXsltParmVersion				= "version";
	private final String								conXsltParmSourceType			= "sourcetype";
	private final String								conXsltParmClassName			= "ClassName";
	private final String								conXsltParmWorkerClassName		= "WorkerClassName";
	private final String								conJavaFilenameExtension		= ".java";
    private  		HashMap pobjHshMap;

	
	private static final Logger	logger			= Logger.getLogger(SourceGenerator.class);
	private void SourceGenerator() {

		//
	}



protected void execute( )  {
	logger.setLevel(Level.DEBUG);
	try {
 		String strXMLFileName = "c:\\temp\\job.xml";
		JSXMLFile objXMLFile = new JSXMLFile(strXMLFileName);
		objXMLFile.MustExist();
		strXMLFileName = strXMLFileName.replaceAll("\\\\", "/");
		String strA[] = strXMLFileName.split("/"); //$NON-NLS-1$
		String strWorkerClassName = strA[strA.length - 1];
		strWorkerClassName.replaceAll("\\..*$","");
	 
 		File objXSLFile = new File("xsl/JSJobDoc2JSOptionSuperClass.xsl");
 		pobjHshMap = new HashMap();
	 
 		setXSLTParameter("package_name", "package");
 		setXSLTParameter("XSLTFileName", objXSLFile.getAbsolutePath());
 		                   
 		setXSLTParameter("default_lang", "en");
 		setXSLTParameter("standalone", "false");

		JSToolBox objTools = new JSToolBox();
		JSDataElementDate objDate = new JSDataElementDate(objTools.Now());
		objDate.setFormatPattern(JSDateFormat.dfTIMESTAMPS24);
		objDate.setParsePattern(JSDateFormat.dfTIMESTAMPS24);
		String strTimeStamp = objDate.FormattedValue();
		setXSLTParameter("timestamp", strTimeStamp);
		String strClassNameExtension = "OptionsSuperClass"; //$NON-NLS-1$

		setXSLTParameter(conXsltParmClassNameExtension, strClassNameExtension);
		setXSLTParameter(conXsltParmExtendsClassName, "JSOptionsClass");
		setXSLTParameter(conXsltParmVersion, "version");
		setXSLTParameter(conXsltParmSourceType, "options"); //$NON-NLS-1$
		setXSLTParameter(conXsltParmClassName, strWorkerClassName);
		setXSLTParameter(conXsltParmWorkerClassName, strWorkerClassName);
		setXSLTParameter("XMLDocuFilename", objXMLFile.getAbsolutePath());
		
 

 		objXMLFile.setParameters(pobjHshMap);
 		doTransform( objXSLFile, objXMLFile);
 		
	/*	 
		CreateTransformer("xsl/JSJobDoc2JSOptionClass.xsl"); //$NON-NLS-1$

		 
		setXSLTParameter(conXsltParmExtendsClassName, strWorkerClassName + strClassNameExtension);
		strClassNameExtension = "Options"; //$NON-NLS-1$
		setXSLTParameter(conXsltParmClassNameExtension, strClassNameExtension);

		setXSLTParameter(conXsltParmClassName, strWorkerClassName + strClassNameExtension);
		config.setTargetFile(strWorkerClassName + strClassNameExtension + conJavaFilenameExtension);

		doTransform(monitor, objXMLFile);

		 
		CreateTransformer("xsl/JSJobDoc2JSAdapterClass.xsl"); //$NON-NLS-1$

		setXSLTParameter(conXsltParmExtendsClassName, "JobSchedulerJob"); //$NON-NLS-1$
		strClassNameExtension = "JSAdapterClass"; //$NON-NLS-1$
		setXSLTParameter(conXsltParmClassNameExtension, strClassNameExtension);

		String strClassName = strWorkerClassName + strClassNameExtension;
		setXSLTParameter(conXsltParmClassName, strClassName);
		setXSLTParameter(conXsltParmWorkerClassName, strWorkerClassName);
		setXSLTParameter(conXsltParmSourceType, "JSJavaApiJob"); //$NON-NLS-1$
		config.setTargetFile(strClassName + conJavaFilenameExtension);

		doTransform(monitor, objXMLFile);

		 
		CreateTransformer("xsl/JSJobDoc2JSWorkerClass.xsl");

		setXSLTParameter(conXsltParmExtendsClassName, "JSToolBox");
		strClassNameExtension = "";
		setXSLTParameter(conXsltParmClassNameExtension, strClassNameExtension);

		strClassName = strWorkerClassName + strClassNameExtension;
		setXSLTParameter(conXsltParmClassName, strClassName);
		setXSLTParameter(conXsltParmWorkerClassName, strWorkerClassName);
		config.setTargetFile(strClassName.trim() + conJavaFilenameExtension);

		doTransform(monitor, objXMLFile);

		 
		CreateTransformer("xsl/JSJobDoc2JSMainClass.xsl");

		setXSLTParameter(conXsltParmExtendsClassName, "JSToolBox");
		strClassNameExtension = "Main";
		setXSLTParameter(conXsltParmClassNameExtension, strClassNameExtension);

		strClassName = strWorkerClassName + strClassNameExtension;
		setXSLTParameter(conXsltParmClassName, strClassName.trim());
		setXSLTParameter(conXsltParmWorkerClassName, strWorkerClassName.trim());
		setXSLTParameter(conXsltParmSourceType, "Main");
		config.setTargetFile(strClassName.trim() + conJavaFilenameExtension);

		doTransform(monitor, objXMLFile);

		 
		CreateTransformer("xsl/JSJobDoc2JSJUnitClass.xsl");

		setXSLTParameter(conXsltParmExtendsClassName, "JSToolBox");
		strClassNameExtension = "JUnitTest";
		setXSLTParameter(conXsltParmClassNameExtension, strClassNameExtension);

		strClassName = strWorkerClassName + strClassNameExtension;
		setXSLTParameter(conXsltParmClassName, strClassName);
		setXSLTParameter(conXsltParmWorkerClassName, strWorkerClassName);
		setXSLTParameter(conXsltParmSourceType, "Junit");
		config.setTargetFile(strClassName + conJavaFilenameExtension);

		doTransform(monitor, objXMLFile);

		 
		CreateTransformer("xsl/JSJobDoc2JSJUnitOptionSuperClass.xsl");

		setXSLTParameter(conXsltParmExtendsClassName, "JSToolBox");
		strClassNameExtension = "OptionsJUnitTest";
		setXSLTParameter(conXsltParmClassNameExtension, strClassNameExtension);

		strClassName = strWorkerClassName + strClassNameExtension;
		setXSLTParameter(conXsltParmClassName, strClassName);
		setXSLTParameter(conXsltParmWorkerClassName, strWorkerClassName);
		setXSLTParameter(conXsltParmSourceType, "Junit");
		config.setTargetFile(strClassName + conJavaFilenameExtension);

		doTransform(monitor, objXMLFile);
		*/

	}
	catch (Exception e) {
		e.printStackTrace(System.err);
		// StatusManager.getManager().han
		

	}
}


private void setXSLTParameter(final String strVarName, final String strVarValue) {
	final String conMethodName = conClassName + "::setXSLTParameter";
	
	String strV = strVarValue;
	String strX = String.format("%3$s: Set parameter '%1$s' to Value %2$s.", strVarName, strV, conMethodName);
	pobjHshMap.put(strVarName, strV);
}


 

private void doTransform(File objXSLFile,final JSXMLFile objXMLFile) throws Exception {
	//File objOutFile = File.createTempFile("SOS", ".tmp");
	File objOutFile = new File("c:\\temp","out.txt");
	//objOutFile.deleteOnExit();
	 

	logger.debug("TempFileName = " + objOutFile.getAbsolutePath()); //$NON-NLS-1$
	logger.debug("TargetFileName = " + objOutFile.getAbsolutePath()); //$NON-NLS-1$

	objXMLFile.Transform( objXSLFile,objOutFile);
	  
	String strGeneratedContent = getContent(objOutFile.getAbsolutePath());
	logger.info("Size of generated content is " + strGeneratedContent.length());
 
}

// TODO fix this in JSFile
private String getContent(final String strFileName) {

	// @SuppressWarnings("unused")
	// final String conMethodName = conClassName + "::getContent ";

	String strB = "";

	int filesize = 0;
	FileInputStream fin = null;
	try {
		fin = new FileInputStream(strFileName);
		final byte[] buffer = new byte[4000];
		while (true) {
			final int bytesRead = fin.read(buffer);
			if (bytesRead == -1) {
				break;
			}
			filesize += bytesRead;
			strB = strB + new String(buffer);
		}

	}
	catch (final IOException e) {
		System.err.println(e);
	}
	finally {
		try {
			if (fin != null) {
				fin.close();
			}
		}
		catch (final IOException e) {
		}
	}

	final String strT = strB.substring(0, filesize);
	return strT;
}  


public static void main(String[] args) {
	SourceGenerator s = new SourceGenerator();
	s.execute();
}
}
